org.bouncycastle.crypto.modes

## Class CFBBlockCipher

- java.lang.Object
- - org.bouncycastle.crypto.modes.CFBBlockCipher

All Implemented Interfaces:
  BlockCipher

    public class CFBBlockCipher
    extends java.lang.Object
    implements BlockCipher

implements a Cipher-FeedBack (CFB) mode on top of a simple cipher.

### Constructor Summary

Constructors
Constructor and Description
`CFBBlockCipher(BlockCipher cipher, int bitBlockSize)` Basic constructor.

### Method Summary

Methods
`int` `decryptBlock(byte[] in, int inOff, byte[] out, int outOff)` Do the appropriate processing for CFB mode decryption.
`int` `encryptBlock(byte[] in, int inOff, byte[] out, int outOff)` Do the appropriate processing for CFB mode encryption.
`java.lang.String` `getAlgorithmName()` return the algorithm name and mode.
`int` `getBlockSize()` return the block size we are operating at.
`BlockCipher` `getUnderlyingCipher()` return the underlying block cipher that we are wrapping.
`void` `init(boolean encrypting, CipherParameters params)` Initialise the cipher and, possibly, the initialisation vector (IV).
`int` `processBlock(byte[] in, int inOff, byte[] out, int outOff)` Process one block of input from the array in and write it to the out array.
`void` `reset()` reset the chaining vector back to the IV and reset the underlying cipher.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### CFBBlockCipher

    public CFBBlockCipher(BlockCipher cipher,
                  int bitBlockSize)

Basic constructor.

Parameters:
  `cipher` - the block cipher to be used as the basis of the feedback mode.
  `bitBlockSize` - the block size in bits (note: a multiple of 8)

### Method Detail

#### getUnderlyingCipher

    public BlockCipher getUnderlyingCipher()

return the underlying block cipher that we are wrapping.

Returns:
  the underlying block cipher that we are wrapping.

#### init

    public void init(boolean encrypting,
            CipherParameters params)
              throws java.lang.IllegalArgumentException

Initialise the cipher and, possibly, the initialisation vector (IV). If an IV isn't passed as part of the parameter, the IV will be all zeros. An IV which is too short is handled in FIPS compliant fashion.

Specified by:
  `init` in interface `BlockCipher`
Parameters:
  `encrypting` - if true the cipher is initialised for encryption, if false for decryption.
  `params` - the key and other data required by the cipher.
Throws:
  `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

#### getAlgorithmName

    public java.lang.String getAlgorithmName()

return the algorithm name and mode.

Specified by:
  `getAlgorithmName` in interface `BlockCipher`
Returns:
  the name of the underlying algorithm followed by "/CFB" and the block size in bits.

#### getBlockSize

    public int getBlockSize()

return the block size we are operating at.

Specified by:
  `getBlockSize` in interface `BlockCipher`
Returns:
  the block size we are operating at (in bytes).

#### processBlock

    public int processBlock(byte[] in,
                   int inOff,
                   byte[] out,
                   int outOff)
                     throws DataLengthException,
                            java.lang.IllegalStateException

Process one block of input from the array in and write it to the out array.

Specified by:
  `processBlock` in interface `BlockCipher`
Parameters:
  `in` - the array containing the input data.
  `inOff` - offset into the in array the data starts at.
  `out` - the array the output data will be copied into.
  `outOff` - the offset into the out array the output will start at.
Returns:
  the number of bytes processed and produced.
Throws:
  `DataLengthException` - if there isn't enough data in in, or space in out.
  `java.lang.IllegalStateException` - if the cipher isn't initialised.

#### encryptBlock

    public int encryptBlock(byte[] in,
                   int inOff,
                   byte[] out,
                   int outOff)
                     throws DataLengthException,
                            java.lang.IllegalStateException

Do the appropriate processing for CFB mode encryption.

Parameters:
  `in` - the array containing the data to be encrypted.
  `inOff` - offset into the in array the data starts at.
  `out` - the array the encrypted data will be copied into.
  `outOff` - the offset into the out array the output will start at.
Returns:
  the number of bytes processed and produced.
Throws:
  `DataLengthException` - if there isn't enough data in in, or space in out.
  `java.lang.IllegalStateException` - if the cipher isn't initialised.

#### decryptBlock

    public int decryptBlock(byte[] in,
                   int inOff,
                   byte[] out,
                   int outOff)
                     throws DataLengthException,
                            java.lang.IllegalStateException

Do the appropriate processing for CFB mode decryption.

Parameters:
  `in` - the array containing the data to be decrypted.
  `inOff` - offset into the in array the data starts at.
  `out` - the array the encrypted data will be copied into.
  `outOff` - the offset into the out array the output will start at.
Returns:
  the number of bytes processed and produced.
Throws:
  `DataLengthException` - if there isn't enough data in in, or space in out.
  `java.lang.IllegalStateException` - if the cipher isn't initialised.

#### reset

    public void reset()

reset the chaining vector back to the IV and reset the underlying cipher.

Specified by:
  `reset` in interface `BlockCipher`